﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinSchedule;
using System.Threading;
using Infragistics.Win.UltraWinSchedule.TaskUI;
using Infragistics.Win.Misc;
using Infragistics.Win.UltraWinEditors;
using System.Net.Sockets;
using System.Net;
using System.Diagnostics;
using Infragistics.Win.UltraWinGrid;

namespace UltraGanttViewWithReminder
{
    public partial class Form1 : Form
    {
        private UltraComboEditor comboEditor;
        private UltraCheckEditor uce;
        private TaskDialog tsDialog;
        public static UltraCalendarInfo info;
        private DataTable dt;

        public Form1()
        {
            InitializeComponent();
            info = ultraCalendarInfo1;

            dt = new DataTable();
            dt.Columns.Add("Name", typeof(string));
            dt.Columns.Add("Start date", typeof(DateTime));
            dt.Columns.Add("Duration", typeof(TimeSpan));
            dt.Columns.Add("Task", typeof(Task));

            Thread ReminderThread = new Thread(new ThreadStart(CheckForReminders));
            ReminderThread.IsBackground = true;
            ReminderThread.Start();
        }

        private void CheckForReminders()
        {
            bool IsExit = true;
            while (IsExit)
            {
                dt.Rows.Clear();
                foreach (Task ts in ultraCalendarInfo1.Tasks.Where(p => p.StartDateTime.AddHours(-1) <= DateTime.Now && p.StartDateTime >= DateTime.Now))
                {
                    if (ts.Tag != null && ts.Tag.GetType() == typeof(Reminder))
                    {
                        Reminder rem = ts.Tag as Reminder;
                        if (rem.Enabled)
                        {
                            if (ts.StartDateTime.AddMinutes(-rem.DisplayInterval) < DateTime.Now)
                            {
                                dt.Rows.Add(ts.Name, ts.StartDateTime, ts.Duration, ts);
                            }
                        }
                    }

                }

                if (dt.Rows.Count > 0)
                {
                    ReminderDialog rd = new ReminderDialog();
                    rd.DataSource = dt;
                    if (rd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                    {
                        foreach (UltraGridRow row in rd.ultraGrid1.Rows)
                        {
                            int TaskIndex = ultraCalendarInfo1.Tasks.IndexOf(row.Cells["Task"].Value);
                            ultraCalendarInfo1.Tasks[TaskIndex].Tag = ((Infragistics.Shared.SubObjectBase)(row.Cells["Task"].Value)).Tag;
                        }
                    }
                }

                Thread.Sleep(1000);
            }
        }

        void TaskDialog()
        {
            tsDialog = new TaskDialog(ultraGanttView1.ActiveTask, ultraCalendarInfo1.Tasks, ultraGanttView1);
            uce = new UltraCheckEditor();
            uce.Parent = tsDialog;
            uce.Text = "Reminder";
            uce.SetBounds(20, 150, 100, 25);
            uce.BringToFront();
            uce.CheckedChanged += new EventHandler(uce_CheckedChanged);
            

            comboEditor = new UltraComboEditor();
            comboEditor.Items.Add(0, "0 minutes before start");
            comboEditor.Items.Add(1, "1 minutes before start");
            comboEditor.Items.Add(5, "5 minutes before start");
            comboEditor.Items.Add(15, "15 minutes before start");
            comboEditor.Items.Add(30, "30 minutes before start");
            comboEditor.Items.Add(45, "45 minutes before start");
            comboEditor.Items.Add(60, "60 minutes before start");
            comboEditor.DropDownStyle = Infragistics.Win.DropDownStyle.DropDownList;
            comboEditor.Parent = tsDialog;
            comboEditor.SetBounds(100, 150, 155, 25);
            comboEditor.BringToFront();
            comboEditor.Enabled = false;
            comboEditor.SelectedIndex = 0;

            if (tsDialog.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                Reminder rem = new Reminder();
                if (uce.Checked)
                {
                    rem.DialogText = tsDialog.Task.Name;
                    rem.DisplayInterval = (int)comboEditor.SelectedItem.DataValue;
                    rem.DisplayIntervalUnits = DisplayIntervalUnits.Minutes;
                    rem.Enabled = true;
                    tsDialog.Task.Tag = rem;
                }
                else
                {
                    rem.Enabled = false;
                }

                ultraCalendarInfo1.Tasks.Add(tsDialog.Task);
            }
        }

        void uce_CheckedChanged(object sender, EventArgs e)
        {
            if (uce.Checked) comboEditor.Enabled = true;
            else comboEditor.Enabled = false; ;
        }

        private void ultraGanttView1_TaskDialogDisplaying(object sender, Infragistics.Win.UltraWinGanttView.TaskDialogDisplayingEventArgs e)
        {
            e.Cancel = true;
            TaskDialog();
        }

        private void ultraGanttView1_TaskAdding(object sender, Infragistics.Win.UltraWinGanttView.TaskAddingEventArgs e)
        {
            e.Cancel = true;
            TaskDialog();
        }
    }
}
